import React, { Component } from 'react';
import ChannelService from '../../services/ChannelService';
import ChannelEntry from './ChannelEntry';

import './ChannelList.scss';

export default class Channellist extends Component<any, any> {
  constructor(props: any) {
    super(props);
    this.state = {
      loaded: false,
      channels: [],
    };
  }

  componentDidMount() {
    ChannelService.fetchAllChannels().then(data => {
      this.setState({ channels: data, loaded: true });
    });
  }
  public render() {
    const { loaded, channels } = this.state;
    if (!loaded) {
      return <div className='loading'>Loading...</div>;
    } else {
      return (
        <ul className='channelList'>
          {channels.map((e: Channel) => {
            return (
              <li key={e.id}>
                <ChannelEntry channel={e} />
              </li>
            );
          })}
        </ul>
      );
    }
  }
}
